// LinePickerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LinePickerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLinePickerDlg dialog


CLinePickerDlg::CLinePickerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLinePickerDlg::IDD, pParent){
	m_pParent = pParent;
	m_nStyle = PS_SOLID;
	m_nWidth = 1;
	m_crColor =RGB(0,255,0);

	//{{AFX_DATA_INIT(CLinePickerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CLinePickerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLinePickerDlg)
	DDX_Control(pDX, IDOK, m_ctrlOK);
	DDX_Control(pDX, IDC_WIDTH, m_ctrlWidth);
	DDX_Control(pDX, IDC_STYLE, m_ctrlStyle);
	DDX_Control(pDX, IDC_COLORBTN, m_ctrlColorBtn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLinePickerDlg, CDialog)
	//{{AFX_MSG_MAP(CLinePickerDlg)
	ON_BN_CLICKED(IDC_COLORBTN, OnColorBtn)
	ON_CBN_SELCHANGE(IDC_WIDTH, OnSelChangeWidth)
	ON_CBN_SELCHANGE(IDC_STYLE, OnSelChangeStyle)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLinePickerDlg message handlers

BOOL CLinePickerDlg::OnInitDialog() {
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_ctrlColorBtn.m_pParent = this;
	m_ctrlColorBtn.SetCurrentColor(m_crColor);

	for (int i=0; i<4;i++){
		m_ctrlWidth.m_Lines[i].nWidth = i+1;
		m_ctrlWidth.m_Lines[i].crColor = m_crColor;
		m_ctrlWidth.m_Lines[i].nPenStyle = m_nStyle;
	}

	for (i=0; i<5;i++){
		m_ctrlStyle.m_Lines[i].nWidth = m_nWidth;
		m_ctrlStyle.m_Lines[i].crColor = m_crColor;
	}

	m_ctrlStyle.m_Lines[0].nPenStyle = PS_SOLID;
	m_ctrlStyle.m_Lines[1].nPenStyle = PS_DASH;
	m_ctrlStyle.m_Lines[2].nPenStyle = PS_DOT;
	m_ctrlStyle.m_Lines[3].nPenStyle = PS_DASHDOT;
	m_ctrlStyle.m_Lines[4].nPenStyle = PS_DASHDOTDOT;

	m_ctrlStyle.AddLine();
	m_ctrlStyle.AddLine();
	m_ctrlStyle.AddLine();
	m_ctrlStyle.AddLine();
	m_ctrlStyle.AddLine();

	m_ctrlWidth.AddLine();
	m_ctrlWidth.AddLine();
	m_ctrlWidth.AddLine();
	m_ctrlWidth.AddLine();

	m_ctrlStyle.SetCurSel(0);
	m_ctrlWidth.SetCurSel(0);

	LineData* pLineData;
	for (int j=0; j<m_ctrlStyle.GetCount(); j++){
		pLineData = (LineData*)m_ctrlStyle.GetItemDataPtr(j);
		if(pLineData->nPenStyle == m_nStyle){
			m_ctrlStyle.SetCurSel(j);
		}
	}
	for (j=0; j<m_ctrlWidth.GetCount(); j++){
		pLineData = (LineData*)m_ctrlWidth.GetItemDataPtr(j);
		if(pLineData->nWidth == m_nWidth){
			m_ctrlWidth.SetCurSel(j);
		}
	}


	Invalidate(true);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CLinePickerDlg::OnColorBtn() {
	// TODO: Add your control notification handler code here
	m_crColor = m_ctrlColorBtn.GetCurrentColor();

	for (int i=0; i<4;i++){
		m_ctrlWidth.m_Lines[i].crColor = m_crColor;
	}

	for (i=0; i<5;i++){
		m_ctrlStyle.m_Lines[i].crColor = m_crColor;
	}
	m_ctrlOK.SetFocus();
	Invalidate(true);
	
}


void CLinePickerDlg::OnSelChangeWidth(){
	// TODO: Add your control notification handler code here
	int j = m_ctrlWidth.GetCurSel();
	if(j != CB_ERR){
		LineData* pLineData = (LineData*)m_ctrlWidth.GetItemDataPtr(j);
		m_nWidth = pLineData->nWidth;

		for (int i=0; i<5;i++){
			m_ctrlStyle.m_Lines[i].nWidth = m_nWidth;
		}

		m_ctrlOK.SetFocus();
		Invalidate(true);
	}
}


void CLinePickerDlg::OnSelChangeStyle() {
	// TODO: Add your control notification handler code here
	int j = m_ctrlStyle.GetCurSel();
	if(j != CB_ERR){
		LineData* pLineData = (LineData*)m_ctrlStyle.GetItemDataPtr(j);
		m_nStyle = pLineData->nPenStyle;
		for (int i=0; i<4;i++){
			m_ctrlWidth.m_Lines[i].nPenStyle = m_nStyle;
		}
		m_ctrlOK.SetFocus();
		Invalidate(true);
	}
}


COLORREF CLinePickerDlg::GetColor(){
	return m_crColor;
}


int CLinePickerDlg::GetStyle(){
	return m_nStyle;
}


int CLinePickerDlg::GetWidth(){
	return m_nWidth;
}


void CLinePickerDlg::SetColor(COLORREF crColor){
	if(crColor>0 && crColor <RGB(255,255,255))
		m_crColor = crColor;
}


void CLinePickerDlg::SetStyle(int nStyle){
	if(nStyle>0)
		m_nStyle = nStyle;
}

void CLinePickerDlg::SetWidth(int nWidth){
	if(m_nWidth>0)
		m_nWidth = nWidth;
}

void CLinePickerDlg::OnPaint(){
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

	}
	else {
/*		CPaintDC dc(this); // device context for painting
		LOGBRUSH lb;
		lb.lbStyle = BS_SOLID;
		lb.lbColor = m_crColor;
		CPen CurPen(PS_GEOMETRIC | m_nStyle, m_nWidth, &lb);
		CPen * pOldPen = dc.SelectObject(&CurPen);
		dc.MoveTo(100,160);
		dc.LineTo(200,160);
		dc.SelectObject(pOldPen);*/
		CDialog::OnPaint();
	}
}